#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <shop>
#include <smartdm>


new Handle:hKvTrails;

new iTeam[MAXPLAYERS+1];
new g_SpriteModel[MAXPLAYERS + 1] = {-1, ...};
new ItemId:selected_id[MAXPLAYERS+1];
new Float:g_fLastPosition[MAXPLAYERS+1][3];

new Handle:prchArray;

public Plugin:myinfo =
{
	name = "[Shop] Trails CS:GO",
	author = "FrozDark (HLModders LLC), Pheonix (˙·٠●Феникс●٠·˙)",
	description = "Trails that folows a player",
	version = "1.1",
	url = "http://www.hlmod.ru/ http://zizt.ru/"
};

public OnPluginStart()
{
	HookEvent("player_spawn", PlayerSpawn);
	HookEvent("player_death", PlayerDeath);
	HookEvent("player_team", PlayerTeam);
		
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			iTeam[i] = GetClientTeam(i);
		}
	}
	
	prchArray = CreateArray(ByteCountToCells(PLATFORM_MAX_PATH));
		
	RegAdminCmd("sm_trails_reload", Command_TrailsReload, ADMFLAG_ROOT, "Reloads trails config list");
	
	if (Shop_IsStarted()) Shop_Started();
}

public OnPluginEnd()
{
	Shop_UnregisterMe();
	for (new i = 1; i <= MaxClients; i++)
	{
		KillTrail(i);
	}
}

public OnMapStart()
{
	LoadKeyStructure();
		
	decl String:buffer[PLATFORM_MAX_PATH];
	for (new i = 0; i < GetArraySize(prchArray); i++)
	{
		GetArrayString(prchArray, i, buffer, sizeof(buffer));
		Downloader_AddFileToDownloadsTable(buffer);
		PrecacheModel(buffer, true);
	}
}

LoadKeyStructure()
{
	if (hKvTrails == INVALID_HANDLE)
	{
		hKvTrails = CreateKeyValues("Trails");
		
		decl String:_buffer[PLATFORM_MAX_PATH];
		Shop_GetCfgFile(_buffer, sizeof(_buffer), "trails.txt");
			
		if (!FileToKeyValues(hKvTrails, _buffer)) SetFailState("\"%s\" not found", _buffer);
			
		KvRewind(hKvTrails);
	}
}

public Shop_Started()
{
	LoadKeyStructure();
	
	decl String:name[64], String:description[64];
	KvGetString(hKvTrails, "name", name, sizeof(name), "Trails");
	KvGetString(hKvTrails, "description", description, sizeof(description));
	
	new CategoryId:category_id = Shop_RegisterCategory("trails", name, description);
	
	decl String:item[64], String:item_description[64], String:buffer[PLATFORM_MAX_PATH];
	KvRewind(hKvTrails);
	if (KvGotoFirstSubKey(hKvTrails))
	{
		ClearArray(prchArray);
		do
		{
			KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
			if (!File_ExtEqual(buffer, "vmt")) continue;
			
			KvGetSectionName(hKvTrails, item, sizeof(item));
			
			if (Shop_StartItem(category_id, item))
			{
				KvGetString(hKvTrails, "description", item_description, sizeof(item_description));
				Shop_SetInfo(item, item_description, KvGetNum(hKvTrails, "price", 500), KvGetNum(hKvTrails, "sell_price", -1), Item_Togglable, KvGetNum(hKvTrails, "duration", 86400), KvGetNum(hKvTrails, "gold_price", 5000), KvGetNum(hKvTrails, "gold_sell_price", 2500));
				Shop_SetCallbacks(OnItemRegistered, OnEquipItem);

				if (KvJumpToKey(hKvTrails, "Attributes", false))
				{
					Shop_KvCopySubKeysCustomInfo(view_as<KeyValues>(hKvTrails));
					KvGoBack(hKvTrails);
				}
				
				Shop_EndItem();
			}
		}
		while (KvGotoNextKey(hKvTrails));
			
		KvRewind(hKvTrails);
	}
}

public OnItemRegistered(CategoryId:category_id, const String:category[], const String:item[], ItemId:item_id)
{
	if (KvJumpToKey(hKvTrails, item))
	{
		decl String:buffer[PLATFORM_MAX_PATH];
		KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
		Downloader_AddFileToDownloadsTable(buffer);
		PrecacheModel(buffer, true);
		PushArrayString(prchArray, buffer);
			
		KvSetNum(hKvTrails, "id", _:item_id);
		KvRewind(hKvTrails);
	}
}

public Action:Command_TrailsReload(client, args)
{
	if (hKvTrails != INVALID_HANDLE)
	{
		CloseHandle(hKvTrails);
		hKvTrails = INVALID_HANDLE;
	}
	
	OnPluginEnd();
	Shop_Started();
	
	ReplyToCommand(client, "Trails config list reloaded successfully!");
	return Plugin_Handled;
}

public ShopAction:OnEquipItem(client, CategoryId:category_id, const String:category[], ItemId:item_id, const String:item[], bool:isOn, bool:elapsed)
{
	if (isOn || elapsed)
	{
		OnClientDisconnect(client);
		selected_id[client] = INVALID_ITEM;
		return Shop_UseOff;
	}
	Shop_ToggleClientCategoryOff(client, category_id);
	selected_id[client] = item_id;
	SpriteTrail(client);
	return Shop_UseOn;
}

public OnMapEnd()
{
	for (new client = 1; client <= MAXPLAYERS; client++)
	{
		g_SpriteModel[client] = -1;
	}
}

public OnClientDisconnect(client)
{
	KillTrail(client);
}

public OnClientDisconnect_Post(client)
{
	iTeam[client] = 0;
	selected_id[client] = INVALID_ITEM;
	g_SpriteModel[client] = -1;
}

public PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	CreateTimer(1.0, GiveTrail, GetEventInt(event, "userid"));
}

public PlayerTeam(Handle:event,const String:name[],bool:dontBroadcast)
{
	iTeam[GetClientOfUserId(GetEventInt(event, "userid"))] = GetEventInt(event, "team");
}

public PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
	KillTrail(GetClientOfUserId(GetEventInt(event, "userid")));
}

public Action:GiveTrail(Handle:timer, any:userid)
{
	SpriteTrail(GetClientOfUserId(userid));
}

bool:SpriteTrail(client)
{
	if (!client)
	{
		return false;
	}

	KillTrail(client);
		
	if (selected_id[client] == INVALID_ITEM || iTeam[client] == 0 || IsFakeClient(client))
	{
		return false;
	}
	if (!IsPlayerAlive(client) || !(1 < iTeam[client] < 4))
	{
		return true;
	}
		
	decl String:item[SHOP_MAX_STRING_LENGTH];
	item[0] = '\0';
	Shop_GetItemById(selected_id[client], item, sizeof(item));
		
	if (!item[0] || !KvJumpToKey(hKvTrails, item))
	{
		PrintToServer("Item %s is not exists");
		return false;
	}

	decl String:buffer[PLATFORM_MAX_PATH];
	KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
		
	new Handle:packk, perekesh = PrecacheModel(buffer, true); 
	CreateDataTimer(0.1, RenderBeam, packk, TIMER_REPEAT);
	WritePackCell(packk, GetClientUserId(client));
	g_SpriteModel[client] = CreateEntityByName("env_sprite", -1);
	DispatchKeyValue(g_SpriteModel[client], "classname", "env_sprite");
	DispatchKeyValue(g_SpriteModel[client], "spawnflags", "1");
	DispatchKeyValue(g_SpriteModel[client], "scale", "0.0");
	DispatchKeyValue(g_SpriteModel[client], "rendermode", "10");
	DispatchKeyValue(g_SpriteModel[client], "rendercolor", "255 255 255 0");
	DispatchKeyValue(g_SpriteModel[client], "model", buffer);
	DispatchSpawn(g_SpriteModel[client]);
	AttachTrail(g_SpriteModel[client], client);
	WritePackCell(packk, g_SpriteModel[client]);
	TE_SetupBeamFollow(g_SpriteModel[client], perekesh, 1, 1.0, 10.0, 10.0, 10, {255, 255, 255, 255});
	TE_SendToAll();
		
	KvRewind(hKvTrails);
		
	return true;
}

public Action:RenderBeam(Handle:timer, Handle:pack)
{
	ResetPack(pack);

	new client = GetClientOfUserId(ReadPackCell(pack));

	if (!client || !IsClientInGame(client) || !IsPlayerAlive(client) || selected_id[client] == INVALID_ITEM || !g_SpriteModel[client] || !IsValidEntity(g_SpriteModel[client]) || ReadPackCell(pack) != g_SpriteModel[client])
		return Plugin_Stop;

	decl Float:m_fPosition[3];
	GetClientAbsOrigin(client, m_fPosition);
	new Float:gg = GetVectorDistance(g_fLastPosition[client], m_fPosition);
	if(gg==0.0) return Plugin_Continue;
	else if(gg<=5.0)
	{
		TE_Start("KillPlayerAttachments");
		TE_WriteNum("m_nPlayer", client);
		TE_SendToAll();
		g_fLastPosition[client] = m_fPosition;
		KillTrail(client);
		SpriteTrail(client);
		return Plugin_Stop;
	}
	g_fLastPosition[client] = m_fPosition;
	return Plugin_Continue;
}

public AttachTrail(ent, client)
{
	decl Float:m_fOrigin[3];
	decl Float:m_fAngle[3];
	new Float:m_fTemp[3] = {0.0, 90.0, 0.0};
	GetEntPropVector(client, Prop_Data, "m_angAbsRotation", m_fAngle);
	SetEntPropVector(client, Prop_Data, "m_angAbsRotation", m_fTemp);
	decl Float:m_fPosition[3] = {0.0, 0.0, 13.0};
	GetClientAbsOrigin(client, m_fOrigin);
	AddVectors(m_fOrigin, m_fPosition, m_fOrigin);
	TeleportEntity(ent, m_fOrigin, m_fTemp, NULL_VECTOR);
	SetVariantString("!activator");
	AcceptEntityInput(ent, "SetParent", client, ent);
	SetEntPropVector(client, Prop_Data, "m_angAbsRotation", m_fAngle);
}

KillTrail(client)
{
	if (g_SpriteModel[client] > MaxClients && IsValidEdict(g_SpriteModel[client]))
	{
		AcceptEntityInput(g_SpriteModel[client], "kill");
	}
	
	g_SpriteModel[client] = -1;
}

stock File_GetExtension(const String:path[], String:buffer[], size)
{
	new extpos = FindCharInString(path, '.', true);
	
	if (extpos == -1)
	{
		buffer[0] = '\0';
		return;
	}

	strcopy(buffer, size, path[++extpos]);
}

stock File_ExtEqual(const String:path[], const String:ext[], bool:caseSensetive = false)
{
	decl String:buf[4];
	File_GetExtension(path, buf, sizeof(buf));
	return StrEqual(buf, ext, caseSensetive);
}